;;==================================================
;;Programe LISP pentru Inteligenta Artificiala
;;==================================================


;;===================================================
;;Capitolul 2;



;;=================================================
;;	Subcapitolul 2.2.7.
;;=================================================


;;Exemplu apel do
(do	((item '(unu doi trei) (rest item))
(number 0 (1+ l)))
((null item) number))



;;Exemplu apel mapcar
(mapcar #'+ '(1 2 3) '(10 20 30))



(defun prescurtari (lista-nume)
	"Intoarce lista prescurtarilor numelor din lista-nume"
	;; prima varianta de implementare
	(if (null names)
		nil
		(nconc (prescurtare (car lista-nume))
			(prescurtari (cdr lista-nume))))


(defun prescurtari (lista-nume)
	"Intoarce lista prescurtarilor numelor din lista-nume"
	;; a doua varianta de implementare, folosind mapcan
	(mapcan #'prescurtare lista-nume))

;; Apelul functiei prescurtari (prima sau a doua varainta) se face astfel:
;;(prescurtari '(mihai dan maria))
;; Trebuie definita functia
;; prescurtare ce ia un nume si intoarce prescurtarile acestuia.



;Exemplu apel maplist
(maplist #'list '(a b) '(d e))

;;=======================================================
;;Subcapitolul 2.3.2
;;
(defun add-one (numar)
	"Aduna unu la argumentul primit"
	(1+ numar))

;; Exemplu de apel pentru apply
(apply #'add-one '(1))


(defun produs (numar1 numar2)
	"Calucleaza produsul numerelor primite ca argumente"
	(* numar1 numar2))
;;Exemplu de apel apply, pentru functie cu doi parametri
(apply #'produs '(2 3))


;;Exemplu apel funcall, pentru o functie cu un singur parametru
(funcall #'add-one 1)

;; ;;Exemplu de apel funcall, pentru functie cu doi parametri
(funcall #'produs 2 3)


;;===========================================================
;;Subcapitolul 2.3.3

(defun f (x &optional (y 1) (z y) u)
	"Functie cu parametri optionali si valori predefinite pentru ei"
	(format t "~%x =~a~&y=~a~&z=~&u=~a~&" x y z u)

;;Exemplu de apel
;;(f 2)

(defun optional-key (&key unu (doi 2))
	"Functie cu parametri optionali 
(format t "~%unu=~a~&doi=~a~&" unu doi)

;;Exemple de apel
(optional-key)
(optional-key :unu 1)

(defun test (x &rest y)
	"Exemplu de functie ce foloseste restul parametrilor"
	(format t "~%x=~a~&y=~a~&" x y))

;;Exemplu apel
(test 1 23 45)

;;Folosirea simultana a mai multor tipuri de parametri optionali
(defun test2 (&rest a &key b)
	(format t "~%a=~a~&b=~a~&" a b))

;;Exemplu apel
(test2 :b 4)


;;=========================================================================
Subcapitolul 2.3.4
;;

;;Exemplu de definire si apel functie lambda
((lambda (x) (* x x)) 4) 


(defun sq (x)
	"Functie ce calculeaza patratul unui numar"
	(* x x))

(defun sq-list (list)
	"Functie ce calculeaza patratele numerelor dintr-o lista"
	;; varianta cu functie auxiliara definita cu defun (functie cu nume)
	(mapcar #'sq list))

;;Exemplu apel
(sq-list '( 1 2 3 4))

(defun sq-list2 (list)
	"Functie ce calculeaza patratele numerelor dintr-o lista"
	;; varianta cu finctie auxiliara fara nume (fubnctie lambda)
	(mapcar #'(lambda (x)
		(* x x))
	list))

;;Exemplu apel
(sq-list2 '(1 2 3 4))


(defun numara-instante (obj liste)
	"Functie ce ia ca argumente un obiect si o lista de liste si intoarce o lista 
cu numrul de aparitii ale obiectului in fiecare din sublistele listei primite ca argument"
  (labels  ((nr-instante (lista)
		(if (consp lista)
			(+ (if (eq (car lista) obj) 1 0)
			  (nr-instante (cdr lst)))
			0)))
	(mapcar '#nr-instante liste)))

;;Exemplu apel
(numara-instante 2 '((1 2 3) (3 2 6) (8 0)))



