;;//////////////////////////////////////////////////////////////
;;
;;3.3 Rezolvarea problemelor utilizand strategii de cautare
;;3.3.2 Problema reginelor
;;
;;//////////////////////////////////////////////////////////////

;; "regine.lsp" - rezolva problema plasarii a N regine pe o tabla de sah cu 
;; latura N, utilizand strategia backtracking. Se porneste de la o stare 
;; initiala specificata de parametri *l* si *c*

(defparameter *l* 1)
(defparameter *c* 2)
(defparameter N 8)
(defparameter *STARE-INITIALA* `((,*l* ,*c*)) )

(defun coloana (x) (cadr x))
(defun linie (x) (car x)) 

(defun estescop-regine (x) (= N (linie (first x))))

(defun succesori-regine (x)
  (let ((linie-curenta (+ 1 (linie (first x))))) 
   (do ((result '()) (i 1 (+ i 1)))
       ((> i N) result)
     (if (este-solutie-partiala (list linie-curenta i) x)
       (setf result (cons (list linie-curenta i) result)))
)))

(defun este-solutie-partiala (x y)
     (and (verifica-coloana (coloana x) y)
          (verifica-diag-st (coloana x) y)
          (verifica-diag-dr (coloana x) y) ))

(defun verifica-coloana (j lista)
   (cond ((null lista) 1 )
         ((= j (coloana (first lista))) nil)
         (t (verifica-coloana j (rest lista)))))

(defun verifica-diag-st (j lista)
   (cond ((null lista) 1)
         ((= (- j 1) (coloana (first lista))) nil)
         (t (verifica-diag-st (- j 1) (rest lista)))))

(defun verifica-diag-dr (j lista)
   (cond ((null lista) 1)
         ((= (+ j 1) (coloana (first lista))) nil)
         (t (verifica-diag-dr (+ j 1) (rest lista)))))

(defun bkt-regine (stari)
        (print stari)
        (cond ((null stari) nil)
              ((estescop-regine stari) 
                   (format t "~& Solutie: ~a " stari)
                   1)
              (t  (do ((aux nil) 
                       (var (succesori-regine stari) 
                            (rest var)))
                      ((null var) aux)
                    (if (bkt-regine 
                           (cons (first var) stari))
                      (progn
                         (setf aux 1)
                         (setf var '())) )))))

;;Exemplu de apel
(bkt-regine *STARE-INITIALA*)
