;;/////////////////////////////////////////////////////////////
;;
;; 4 Logica si demonstrarea teoremelor
;; 4.4 Demonstrarea teoremelor prin respingere rezolutiva
;; 4.4.3 Implementarea rezolutiei liniare de intrare
;;
;;//////////////////////////////////////////////////////////////

;; "rezliniara.lsp - rezolutia liniara de intrare, fara factorizare, 
;; folosind backtracking

(load "unificare")

(defun pozitiv-p (literal)
  "Intoarce T daca literal este un literal pozitiv."
  (and (consp literal) (eq (first literal) 'poz)))

(defun negat-p (literal)
  "Intoarce T daca literal este un literal negativ."
  (and (consp literal) (eq (first literal) 'neg)))

(defun literal (predicat &optional (semn 'poz))
  "Intoarce literalul (semn predicat)."
  (list semn predicat))

(defun semn (literal)
  "Intoarce semnul unui literal."
  (first literal))

(defun semn-complementar (literal)
  "Intoarce semnul complementar sau nil daca literalul este incadrat."
  (cond ((eq (semn literal) 'poz) 'neg)
        ((eq (semn literal) 'neg) 'poz)))

(defun predicat (literal)
  "Intoarce predicatul unui literal."
  (cadr literal))

(defun sterge-duplicate (clauza)
  "Intoarce clauza fara literali duplicati."
  (let (clauza1)
    (dolist (literal clauza (reverse clauza1))
      (unless (member literal clauza1 :test #'equal)
        (push literal clauza1)))))

(defun sterge-literal (literal clauza)
  "Intoarce clauza din care a fost eliminat literalul."
  (do* ((C clauza (rest C))
        (L (first C) (first C))
        clauza-rezultat)
      ((or (equal L literal) (null C))
       (append clauza-rezultat (rest C)))
    (push L clauza-rezultat)))

(defun substituie-variabile-in-clauza (clauza mgu)
  "Intoarce claza in care variabilele au fost substituite."
  (mapcar #'(lambda (L)
              (literal (substituie-variabile (predicat L) mgu) (semn L)))
          clauza))

(defun rezolvent (C B)
   (let ((lista-rezolventi '()))
      (dolist (literal-C C (reverse lista-rezolventi))
        (dolist (literal-B B )
            (when (eq (semn-complementar literal-C) (semn literal-B))
               (multiple-value-setq (succes mgu)
                 (unifica (predicat literal-C) (predicat literal-B)))
               (if succes
                (push
                   (list 
                    (sterge-duplicate
                     (if mgu  
                        (substituie-variabile-in-clauza
                         (append (sterge-literal literal-C C)
                                 (sterge-literal literal-B B)) mgu)
                        (append (sterge-literal literal-C C)
                                (sterge-literal literal-B B))))
                     mgu) 
                   lista-rezolventi))))))) 

(defun print-solutie (CALE-C CALE-B)
   (let ((Clauze-centrale (reverse CALE-C))(Clauze-laterale (reverse CALE-B)))
      (do* ((C-aux Clauze-centrale (rest C-aux))
            (B-aux Clauze-laterale (rest B-aux))
            (Ci (caar C-aux) (caar C-aux) )(Bi (car B-aux) (car B-aux))
            (mgu (cadadr C-aux) (cadadr C-aux)))
           ((null B-aux) (progn (terpri) (prin1 "CLAUZA-VIDA")))
         (terpri)
         (prin1 Ci) (prin1 "  ") (prin1 Bi)
         (terpri)
         (prin1 mgu)
         (terpri) (prin1"----------------------"))))

(defvar *AD-MAX* 0)
                                     
(defun respingere (C0 S &optional(*AD-MAX* 10))
   (let ((FRONTIERA-C (list (list C0 nil))) (FRONTIERA-B '())
         (solutie '()))
      (labels ((respingere-bkt (CALE-C CALE-B adancime)
                 ;;(print CALE-C) (print adancime)
                 (cond ((null CALE-C) nil)
                       ((null (caar CALE-C)) 
                        (push (list cale-C cale-B) solutie))
                       ((> adancime *AD-MAX*) nil)
                       (t
                         ;;(print "enter")
                         (dolist (Bi S )
                            ;;(print "rezolvent:")
                            ;;(print (rezolvent (caar CALE-C) Bi))
                            (dolist (Cik (rezolvent (caar CALE-C) Bi) )
                               ;;(print "Cik:")
                               ;;(print Cik)
                               (respingere-bkt (cons Cik CALE-C)
                                               (cons Bi CALE-B)  
                                               (+ 1 adancime))))))))
        (respingere-bkt FRONTIERA-C FRONTIERA-B 0)
        (print-solutie (caar solutie) (cadar solutie))))) 


;;Exemplu de apel
(setq SSS 
  '( ((poz (p (*VAR* x))))
     ((neg (p (*VAR* x))) (poz (q (*VAR* x) a)))
     ((neg (q (*VAR* y) a))) ) )

(setq CC0 '((poz (p (*VAR* x)))))

(respingere CC0 SSS 4)
    
